AddThickenFeature

Creator
Creator

Hi.

I'm trying to use AddThickenFeature method

Here is the code:

if (Thickness > 0)
{
SolidEdgePart.Model SE_Model = New_SE_Part.Models.AddThickenFeature(SolidEdgePart.FeaturePropertyConstants.igReverseNormalSideDummy, Thickness, Chain_Faces_List.Count, Chain_Faces_List.ToArray());

}

in my case the Thickness is 0.003[m]

The Chain_Faces_List contains 3 tangent connected faces (2 planar faces and one round between them)

When i call this method, i get error: "Value does not fall within the expected range."

 

I can't understand what is a problem here.

The only value i pass to the method that can be in some range is the Thickness.

If Thickness value is greatter than zero it should be valid value for the method.

 

Also, the Faces in Chain_Faces_List are defined property. I highlighted them on the graphics windows, so i can see them countinuently connected.

 

Maybe someone used the Thicken, or AddThickenFeature method before? Both methods have the same parameters.

 

Thanks

2 REPLIES

Re: AddThickenFeature

Solution Partner Phenom Solution Partner Phenom
Solution Partner Phenom

I had to do some extensive testing to figure this one out. The confusion for the API consumer (us) is the 'Side' parameter is of type FeaturePropertyConstants enumeration but only a handful of the constants are valid for the AddThickenFeature() method. I've run out of time for the moment but my testing shows that SolidEdgePart.FeaturePropertyConstants.igLeft and SolidEdgePart.FeaturePropertyConstants.igRight are valid 'Side' values depending on which direction you're trying to go. There may be others but I haven't gotten that far yet. I also wanted to mention that there are actually two methods to accomplish adding thicken features.

 

  1. Models.AddThickenFeature()
  2. Model.Thickens.Add()

It is also important to realize that if this method succeeds, it will invalid any reference you have to a previous Model object or any of it's children. I figured that out the hard way. Even though Models is a collection which implies that there can be 0-N models, I have only ever seen 0-1. So after the method succeeds, it seems that it deletes the existing model and replaces it with the updated model.

Jason Newell
Applications Architect
www.jasonnewell.net

Re: AddThickenFeature

Creator
Creator
Hi.
The Left and Right side, how should i know what side to use?
In my case there is some surfaces chain i want to thicken "out". best definition of direction i need is reverse to normal. is exactly what i need. but in every case it can be another "normal".
The second thing, by Models.AddThickenFeature i will create a Model. in my case is exactly what i need, because i have no Model in the file. Only surfaces i want to become a solid Model. So in my case i need exactry this feature.
I'll try also the Left and Right option. Maybe, if it will work, i could find some workaround to find the reverse to nomal direction.